
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;


/*
Classe de test pour le déplacement du cavalierB.
 */
public class TestDepC {
    @Parameterized.Parameter
    protected Cavalier cavalierB;
    @Parameterized.Parameter
    protected Cavalier cavalierN;
    @Parameterized.Parameter
    protected Echiquier ech;

    @Before
    public void setUP(){
        cavalierB = new Cavalier(Piece.BLANC);
        cavalierN = new Cavalier(Piece.NOIR);
        ech = new Echiquier();
    }

    @After
    public void tearDown(){
    }

    @Test
    public void TestPlacement() throws Exception{
        ech.placer(cavalierB, 0, 0);
        Assert.assertEquals(cavalierB,ech.getPiece(0,0));
    }

    @Test
    public void TestDeplacement() throws Exception{
        ech.placer(cavalierB,0,0);
        ech.deplacer(0,0,1,2);
        Assert.assertEquals(cavalierB, ech.getPiece(1,2));
    }

    @Test
    public void TestPrise() throws Exception{
        ech.placer(cavalierB, 0,0);
        ech.placer(cavalierN, 1,2);
        ech.deplacer(0,0,1,2);
        Assert.assertEquals(cavalierB,ech.getPiece(1,2));
    }
}