import junit.framework.TestCase;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;

import java.util.ArrayList;

import static org.junit.Assert.*;

/*
Classe de test pour le déplacement du cavalierB.
 */
public class TestDepP {
    @Parameterized.Parameter
    protected Pion pionB;
    @Parameterized.Parameter
    protected Pion pionN;
    @Parameterized.Parameter
    protected Pion pionB2;
    @Parameterized.Parameter
    protected Echiquier ech;

    @Before
    public void setUP(){
        pionB = new Pion(Piece.BLANC);
        pionN = new Pion(Piece.NOIR);
        pionB2 = new Pion(Piece.BLANC);
        ech = new Echiquier();
    }

    @After
    public void tearDown(){
    }

    @Test
    public void TestDeplacement() throws Exception{
        /*
        Pion Blanc qui commence sur la premiere ligne
         */
        ech.placer(pionB, 6,0);
        ech.deplacer(6,0,4,0);
        Assert.assertEquals(pionB,ech.getPiece(4,0));
        /*
        Pion Noir qui commence sur la premiere ligne
         */
        ech.placer(pionN,1,0);
        ech.deplacer(1,0,3,0);
        Assert.assertEquals(pionN,ech.getPiece(3,0));
        /*
        Pion qui avance depuis une autre case que la première
         */
        ech.placer(pionB2, 5,6);
        ech.deplacer(5,6,4,6);
    }

    @Test
    public void TestPrise() throws Exception{
        ech.placer(pionB,5,5);
        ech.placer(pionN, 1,1);
        ech.afficherDepPossibles(5,5);
        ech.afficherDepPossibles(1,1);
        //System.out.println(ech);
        //ech.deplacer(5,5,4,6);
        //Assert.assertEquals(pionB, ech.getPiece(4,6));
    }
}